=== debian/changelog ===
pugixml (1.12.1-1) UNRELEASED; urgency=medium

  * update

 -- Vasudev Kamath <vasudev@copyninja.info>  Wed, 18 May 2022 22:45:44 -0400

pugixml (1.12.1-1) unstable; urgency=medium

  [ Jonas Smedegaard ]
  * remove myself as uploader

  [ Gianfranco Costamagna ]
  * Convert to debhelper compat level 13
  * Fixup syntax for new cmake variables
  * Add R^3: no
  * Fix watch file and upgrade to v4
  * Bump std-version to 4.6.0
  * New upstream version 1.12.1
  * Patch refresh
  * Update copyright years
  * Drop dbgsym migration
  * Drop duplicated section in control file
  * Drop dbgsym migration code, useless now
  * Update copyright file

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 23 Feb 2022 10:07:27 +0100
