## pugixml 1.13

=== debian/changelog ===
pugixml (1.13-0.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Update symbols (Closes: #1015595)

 -- Jochen Sprickerhof <jspricke@debian.org>  Mon, 05 Dec 2022 20:21:58 +0100

pugixml (1.13-0.1) unstable; urgency=medium

  * Non-maintainer upload.

  [ Debian Janitor ]
  * Set upstream metadata fields: Security-Contact.
  * Drop unused build-dependency on cdbs.

  [ Jochen Sprickerhof ]
  * New upstream version 1.13
  * Rebase patches
  * Bump policy version (no changes)
  * Move package description to source package
  * Fix pkgkde-symbolshelper
  * Add new symbols
  * Drop unused lintian-overrides

 -- Jochen Sprickerhof <jspricke@debian.org>  Mon, 05 Dec 2022 12:55:07 +0100
