=== debian/control ===
Source: pugixml
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 13),
 cmake,
 dh-sequence-pkgkde-symbolshelper,
Maintainer: Vasudev Kamath <vasudev@copyninja.info>
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: https://pugixml.org/
Vcs-Git: https://salsa.debian.org/debian/pugixml.git
Vcs-Browser: https://salsa.debian.org/debian/pugixml
Description: Light-weight C++ XML processing library
 pugixml is a lightweight C++ XML processing library with XPath
 support. It features:
  * DOM like interface with rich traversal/modification capabilities
  * Extermely fast non-validating XML parser which constructs the DOM
    tree from an XML file/buffer.
  * XPath 1.0 implementation for complex data-driven tree queries
  * Full Unicode support with Unicode interface variants and automatic
    encoding conversions.

Package: libpugixml1v5
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Multi-Arch: same
Conflicts: libpugixml1
Replaces: libpugixml1
Description: ${source:Synopsis}
 ${source:Extended-Description}
 .
 This library is extremely portable and easy to integrate and use.
 .
 Since pugixml has a DOM parser, it can't process XML documents that do
 not fit in memory; also the parser is a non-validating one, so if you
 need DTD or XML Schema validation, the library is not for you.

Package: libpugixml-dev
Section: libdevel
Architecture: any
Depends: libpugixml1v5 (= ${binary:Version}),
 ${misc:Depends},
 ${devlibs:Depends}
Multi-Arch: same
Description: ${source:Synopsis} (development)
 ${source:Extended-Description}
 .
 This package provides required development header files which allows
 integrating pugixml with your application.

Package: pugixml-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: ${source:Synopsis} (documentation)
 ${source:Extended-Description}
 .
 This package contains API documentation.
