=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
  cmake,
  dh-sequence-pkgkde-symbolshelper,
 Maintainer: Vasudev Kamath <vasudev@copyninja.info>
-Standards-Version: 4.6.1
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://pugixml.org/
 Vcs-Git: https://salsa.debian.org/debian/pugixml.git
