=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,4 @@
 #!/usr/bin/make -f
-
-include /usr/share/pkg-kde-tools/makefiles/1/cdbs/symbolshelper.mk
 
 %:
 	dh $@ --buildsystem=cmake
