=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/pugixml-$1\.tar\.gz/ \
  https://github.com/zeux/pugixml/tags .*/v?(\d\S*)\.tar\.gz
